// 001 u_input_form
// 02 may 2000

(*$r+*)

unit u_f_confirm;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls,
      u_types_constants
      ;

    type Tinput_form =
             class(TForm)
                 edt_input: TEdit;
                 procedure edt_inputKeyPress(Sender: TObject; var Key: Char);
               private
                 m_input_type: Char;
                 m_valid_set: t_set_of_characters;
               public
             end;

    Function f_read_valid_character(p_x, p_y: Integer; p_prompt: String; p_valid_set: t_set_of_characters): Char;
    Function f_input_integer(p_x, p_y: Integer; p_prompt: String; p_initial_value: Integer): Integer;
    Function f_input_string(p_x, p_y: Integer; p_prompt: String; p_valid_set: t_set_of_characters): String;
    Function f_input_pascal_string(p_x, p_y: Integer; p_prompt: String): String;

  implementation

    {$R *.DFM}

    Function f_read_valid_character(p_x, p_y: Integer; p_prompt: String; p_valid_set: t_set_of_characters): Char;
      begin
        with tInput_form.Create(Nil) do
        begin
          Top:= p_y; Left:= p_x;
          Caption:= p_prompt;

          m_input_type:= 'c';
          m_valid_set:= p_valid_set;
          // ActiveControl:= edt_input;
          Result:= Chr(ShowModal);
          Free;
        end; // with tInput_form
      end; // f_read_valid_character

    Function f_input_integer(p_x, p_y: Integer; p_prompt: String; p_initial_value: Integer): Integer;
      begin
        with tInput_form.Create(Nil) do
        begin
          Top:= p_y; Left:= p_x;
          Caption:= p_prompt;

          m_input_type:= 'i';
          edt_input.Text:= IntToStr(p_initial_value);
          // ActiveControl:= edt_input;
          Result:= ShowModal;

          Free;
        end; // with tInput_form
      end; // f_input_integer

    Function f_input_string(p_x, p_y: Integer; p_prompt: String; p_valid_set: t_set_of_characters): String;
      begin
        with tInput_form.Create(Nil) do
        begin
          Top:= p_y; Left:= p_x;
          Caption:= p_prompt;

          m_input_type:= 's';
          m_valid_set:= p_valid_set;
          if ShowModal= mrOk
            then Result:= edt_input.Text
            else begin
                Result:= '';
                Exit;
              end;
          Free;
        end; // with tInput_form
      end; // f_input_string

    Function f_input_pascal_string(p_x, p_y: Integer; p_prompt: String): String;
      begin
        Result:= f_input_string(p_x, p_y, p_prompt, k_letters+ k_digits+ ['_']);
      end; // f_input_pascal_string

    procedure Tinput_form.edt_inputKeyPress(Sender: TObject; var Key: Char);
      begin
        case m_input_type of
          'c' : if Key in m_valid_set
                  then ModalResult:= Ord(Key);
          'i' : if Key= Chr(13)
                  then begin
                      ModalResult:= StrToInt(edt_input.Text);
                    end;
          's' : begin
                  if not (Key in m_valid_set)
                    then  Beep;
                  if Key= Chr(13)
                    then begin
                        ModalResult:= mrOk;
                        Key:= Chr(0);
                      end;
                end;
        end;
      end; // edt_inputKeyPress

end.
