// 003 u_directory_favorite_list
// 15 mar 2018

// -- (C) Felix John COLIBRI 2018
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_directory_favorite_list;
  Interface
    Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls, FileCtrl, ExtCtrls, ComCtrls
        ;

    type TForm1=
             class(TForm)
                 command_panel: tPanel;
                 exit_panel: tPanel;
                 exit_: tButton;
                 clear_: tButton;
                 help_: tButton;
                 dir_pagecontrol: tPageControl;
                 dir_tabsheet: tTabSheet;
                 favorites_panel: tPanel;
                 DirectoryListbox1: tDirectoryListbox;
                 dir_file_splitter: tSplitter;
                 file_panel: tPanel;
                 FileListbox1: tFileListbox;
                 left_splitter: tSplitter;
                 display_pagecontrol: tPageControl;
                 display_tabsheet: tTabSheet;
                 Memo1: tMemo;
                 Procedure Form1Create(Sender: tObject);
                 Procedure Form1Close(Sender: TObject; var Action: TCloseAction);
                 Procedure exit_Click(Sender: tObject);
                 Procedure clear_Click(Sender: tObject);
                 Procedure help_Click(Sender: tObject);
                 Procedure DirectoryListbox1Change(Sender: tObject);
                 Procedure FileListbox1Click(Sender: tObject);
               private
//                 procedure handle_favorite_path_click(p_path, p_extension: String);
               public
             end; // TForm1

    var Form1: tForm1= Nil;

  implementation
    Uses u_c_display, u_c_log
        , u_help
        // , u_c_favorite_path_list
        , u_exe
        , u_file, u_dir
        , u_c_ini_file
        , u_handle_files_in_dirs

        , u_strings

        , u_c_favorite_path_list_2

        ;

    {$R *.DFM}

    Const k_xxx_path=                'c:\prog\xxx\';
          k_xxx_file_name=           'pascal.pas';
          k_xxx_path_ini_key=        'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    Var g_path:          String= k_xxx_path;
        g_file_name:     String= k_xxx_file_name;
        g_c_ini_file:    c_ini_file= Nil;
        g_file_count:    Integer= 0;
        g_c_favorite_path_list: c_favorite_path_list= Nil;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        display_path_and_file;

        Inc(g_file_count);

        display('  '+ p_file_name);
      end; // my_call_back

    // -- events

    procedure TForm1.Form1Create(Sender: TObject);
      var l_favorites_full_file_name: String;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_xxx_file_name);
        end; // with g_c_ini_file
        display_path_and_file;

        // check_name(k_initial_directory);
        // DirectoryListBox1.Directory:= k_initial_directory;

        f_create_path(f_exe_path+ 'favorites\');
        l_favorites_full_file_name:= f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt';
        if not FileExists(l_favorites_full_file_name)
          then save_string('', l_favorites_full_file_name) ;
        g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            l_favorites_full_file_name, favorites_panel, DirectoryListBox1);

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1, Items do
          ItemIndex:= IndexOf(g_file_name);
      end; // Form1Create

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // Form1Close

    // -- call handler

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);

        g_c_ini_file.save_to_default_file;
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
        l_path:= f_without_ending_slash(g_path);

        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;
        g_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, my_call_back, Nil);

        display_line;
        display(Format('FINISHED %3d ', [g_file_count]));
      end; // handle_the_files

(*
    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListbox1, p_path);
      end; // handle_favorite_path_click
*)
    procedure TForm1.help_Click(Sender: TObject);
      begin
        display_help;
      end; // help_Click


end. // test_string_filter

