// 002 u_c_favorite_path_list_2
// 15 mar 2018

// -- (C) Felix John COLIBRI 2018
// -- documentation: http://www.felix-colibri.com

// -- contains a reference to the tDirectoryListbox => bidir update
// -- new syntacx
// --    nnn ppp ppp | ee ee  eee

// -- todo
// --   move up down tbe names
// --   propagate extensions to listbox


(*

to include in a main form:
uses
      , u_c_favorite_path_list_2


globals
        g_c_favorite_path_list: c_favorite_path_list= Nil;

form create
      var l_favorites_full_file_name: String;

        l_favorites_full_file_name:= f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt';
        if not FileExists(l_favorites_full_file_name)
          then check_name(l_favorites_full_file_name)
          else g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            l_favorites_full_file_name, favorites_panel, DirectoryListBox1);

*)


(*$r+*)

unit u_c_favorite_path_list_2;
  interface
    uses Classes, Controls, StdCtrls, ExtCtrls, FileCtrl
        , u_c_basic_object;

    type c_favorite_path= // one "favorite_path"
             Class(c_basic_object)
               // -- m_name: the displayed name in the memos
               // -- the m_parameter is not currently used (could be a Mask)
               m_path, m_parameter: String;

               Constructor create_favorite_path(p_name, p_path, p_parameter: String);
               function f_display_favorite_path: String;
               function f_c_self: c_favorite_path;
               function f_normalized_parameter_list: String;

               Destructor Destroy; Override;
             end; // c_favorite_path

         // t_po_notify_favorite_click= procedure(p_path, p_parameter: String) of Object;

         c_favorite_path_list= // "favorite_path" list
             Class(c_basic_object)
               // -- m_name: the full file name
               m_c_favorite_path_list: tStringList;

               m_c_directory_listbox_ref: tDirectoryListbox;
               m_c_panel_ref: tPanel;
               m_c_list_box: tListBox;

               m_full_file_name: String;
               // m_c_on_listbox_click: t_po_notify_favorite_click;

               Constructor create_favorite_path_list(p_name: String;
                   p_c_panel_ref: tPanel;
                   p_c_directory_listbox_ref: tDirectoryListbox);

               function f_favorite_path_count: Integer;
               function f_c_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
               function f_index_of(p_favorite_path_name: String): Integer;
               function f_c_find_by_favorite_path(p_favorite_path_name: String): c_favorite_path;
               procedure add_favorite_path(p_favorite_path_name: String; p_c_favorite_path: c_favorite_path);
               function f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
               function f_c_add_unique_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
               function f_c_delete_favorite_path(p_favorite_path_index: Integer): c_favorite_path;

               procedure display_favorite_path_list;

               function f_path_name_index(p_path_name: String): Integer;
               procedure create_listbox;

               procedure handle_favorite_listbox_click(p_c_sender: tObject);
               procedure handle_listbox_keypress(p_c_sender: tObject; var pv_key: Char);

               procedure handle_directory_listbox_keypress(p_c_sender: tObject; var pv_key: Char);
               procedure handle_directory_listbox_click(p_c_sender: tObject);

(*
               procedure handle_directory_listbox_mouse_move(p_c_sender: tObject;
                   p_shif_state: tShiftState; p_x, p_y: Integer);
               procedure handle_directory_listbox_mouse_down(p_c_sender: tObject;
                   p_mouse_button: TMouseButton; p_shif_state: TShiftState; p_x, p_y: Integer);
*)
               procedure handle_directory_listbox_drag_over(
                   p_c_sender, p_c_source: TObject; p_x, p_y: Integer;
                   p_drag_state: TDragState; var pv_accept: Boolean);
               procedure handle_directory_listbox_drag_dop(
                   p_c_sender, p_c_source: TObject; p_x, p_y: Integer);

               procedure load_from_file(p_full_file_name: String);
               procedure save_to_file;

               Destructor Destroy; Override;
             end; // c_favorite_path_list

  implementation
    uses SysUtils
        , u_c_display, u_types_constants
        , u_strings
        , u_dir
        , u_f_confirm
        ;

    // -- c_favorite_path

    Constructor c_favorite_path.create_favorite_path(p_name, p_path, p_parameter: String);
      begin
        Inherited create_basic_object(p_name);

        m_path:= p_path;
        m_parameter:= p_parameter;
        if m_parameter= '='
          then m_parameter:= 'txt';
      end; // create_favorite_path

    function c_favorite_path.f_display_favorite_path: String;
      begin
        Result:= Format('%-21s | %-50s [%s]', [m_name, m_path, m_parameter]);
      end; // f_display_favorite_path

    function c_favorite_path.f_c_self: c_favorite_path;
      begin
        Result:= Self;
      end; // f_c_self

    function c_favorite_path.f_normalized_parameter_list: String;
      var l_index: integer;
          l_parameter: String;
      begin
        l_index:= 1;
        Result:= '';
        while l_index<= Length(m_parameter) do
        begin
          l_parameter:= f_string_extract_non_blank(m_parameter, l_index);
          l_parameter:= f_remove_start_if_start_is_equal_to(l_parameter, '.');
          
          Result:= Result+ l_parameter;
          if l_index< Length(m_parameter)
            then Result:= Result+ ' ';
        end;
      end; // f_normalized_parameter_list

    Destructor c_favorite_path.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_favorite_path_list

    Constructor c_favorite_path_list.create_favorite_path_list(p_name: String;
        p_c_panel_ref: tPanel;
        p_c_directory_listbox_ref: tDirectoryListbox);
      begin
        Inherited create_basic_object(p_name);

        m_c_panel_ref:= p_c_panel_ref;

        m_c_directory_listbox_ref:= p_c_directory_listbox_ref;

        m_c_favorite_path_list:= tStringList.Create;
        m_full_file_name:= m_name;

        if FileExists(m_name)
          then begin
              load_from_file(m_name);
              create_listbox;
            end
          else begin
              display('*** no_favorites '+ m_name);
              create_listbox;
            end;

        with m_c_directory_listbox_ref do
        begin
          OnKeyPress:= handle_directory_listbox_keypress;
          OnClick:= handle_directory_listbox_click;
        end; // with m_c_directory_listbox_ref
      end; // create_favorite_path_line

    function c_favorite_path_list.f_favorite_path_count: Integer;
      begin
        Result:= m_c_favorite_path_list.Count;
      end; // f_favorite_path_count

    function c_favorite_path_list.f_c_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
      begin
        Result:= c_favorite_path(m_c_favorite_path_list.Objects[p_favorite_path_index]);
      end; //  f_c_favorite_path

    function c_favorite_path_list.f_index_of(p_favorite_path_name: String): Integer;
      begin
        Result:= m_c_favorite_path_list.IndexOf(p_favorite_path_name);
      end; // f_index_of

    function c_favorite_path_list.f_c_find_by_favorite_path(p_favorite_path_name: String): c_favorite_path;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_favorite_path_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_favorite_path(m_c_favorite_path_list.Objects[l_index_of]);
      end; // f_c_find_by_name

    procedure c_favorite_path_list.add_favorite_path(p_favorite_path_name: String; p_c_favorite_path: c_favorite_path);
      begin
        m_c_favorite_path_list.AddObject(p_favorite_path_name, p_c_favorite_path);
      end; // add_favorite_path

    function c_favorite_path_list.f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
      begin
        Result:= c_favorite_path.create_favorite_path(p_favorite_path_name, p_path, p_parameter);
        add_favorite_path(p_favorite_path_name, Result);
      end; // f_c_add_favorite_path

    function c_favorite_path_list.f_c_add_unique_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_favorite_path_name);
        if l_index_of>= 0
          then Result:= f_c_favorite_path(l_index_of)
          else Result:= f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter);
      end; // f_c_add_unique_favorite_path

    procedure c_favorite_path_list.display_favorite_path_list;
      var l_favorite_path_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_favorite_path_count));

        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          display(f_c_favorite_path(l_favorite_path_index).f_display_favorite_path);
      end; // display_favorite_path_list

    procedure c_favorite_path_list.handle_favorite_listbox_click(p_c_sender: tObject);
      var l_c_favorite_path: c_favorite_path;
      begin
        with m_c_list_box do
          l_c_favorite_path:= f_c_find_by_favorite_path(Items[ItemIndex]);
        display(l_c_favorite_path.f_display_favorite_path);

        with l_c_favorite_path do
          set_directory_listbox_directory(m_c_directory_listbox_ref, m_path);
      end; // handle_favorite_listbox_click

    procedure c_favorite_path_list.handle_listbox_keypress(p_c_sender: tObject; var pv_key: Char);
      var l_favorite_index: integer;
      begin
        if pv_key= '-'
          then begin
              with m_c_list_box do
              begin
                l_favorite_index:= ItemIndex;
                Items.Delete(l_favorite_index);
              end;

              // -- remove from list
              f_c_delete_favorite_path(l_favorite_index).Free;

              save_to_file;
            end;
      end; // handle_listbox_keypress

    procedure c_favorite_path_list.create_listbox;

      function f_c_listbox(p_left, p_top, p_with, p_height: Integer): tListBox;
        begin
          Result:= tListBox.Create(Nil);
          with Result Do
          begin
            Name:= 'mylistbox';
            Parent:= m_c_panel_ref;
            Align:= alClient;
            // HideSelection:= False;
            OnClick:= handle_favorite_listbox_click;
          end; // with Result
        end; // f_c_listbox

      var // l_c_list_box: tListBox;
          l_favorite_path_index: Integer;

      begin // create_listbox
        m_c_list_box:= f_c_listbox(0, 0, 0, 0);

        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          with f_c_favorite_path(l_favorite_path_index) do
            m_c_list_box.Items.Add(m_name);

        with m_c_list_box do
        begin
          OnKeyPress:= handle_listbox_keypress;

          DragMode:= dmAutomatic;
          OnDragOver:= handle_directory_listbox_drag_over;
          OnDragDrop:= handle_directory_listbox_drag_dop;
        end; // with m_c_list_box
      end; // create_listbox

    function c_favorite_path_list.f_c_delete_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
      begin
        Result:= f_c_favorite_path(p_favorite_path_index);
        m_c_favorite_path_list.Delete(p_favorite_path_index);
      end; // f_c_delete_favorite_path

    procedure c_favorite_path_list.handle_directory_listbox_keypress(
        p_c_sender: tObject; var pv_key: Char);
      var l_path_name, l_path: String;
          l_c_favorite_path: c_favorite_path;
          l_path_index: Integer;
          l_found_path: Boolean;
      begin
        if pv_key= '+'
          then begin
              l_path_name:= f_input_string(10, 10, 'enter path name', k_letters+ k_digits+ ['_']);
              with m_c_directory_listbox_ref do
                l_path:= GetItemPath(ItemIndex)+ '\';

              with m_c_favorite_path_list do
              begin
                l_found_path:= False;
                for l_path_index:= 0 to Count- 1 do
                  with f_c_favorite_path(l_path_index) do
                    if SameText(l_path, m_path)
                      then begin
                          l_found_path:= True;
                          m_name:= l_path_name;
                          m_c_favorite_path_list[l_path_index]:= l_path_name;
                          m_c_list_box.Items[l_path_index]:= l_path_name;
                          // l_c_favorite_path:= f_c_self;
                          Break;
                        end;

                if not l_found_path
                  then begin
                      l_c_favorite_path:= f_c_add_unique_favorite_path(l_path_name, l_path, '*');
                      with m_c_list_box.Items do
                        AddObject(l_path_name, l_c_favorite_path);
                    end;
              end; // with m_c_favorite_path_list

              display_favorite_path_list;

              save_to_file;
            end;
      end; // handle_directory_listbox_keypress

    procedure c_favorite_path_list.handle_directory_listbox_click(p_c_sender: tObject);
      var l_path: String;
          l_path_index: Integer;
      begin
        with m_c_directory_listbox_ref do
          l_path:= GetItemPath(ItemIndex);

        display('look for '+ l_path);
        with m_c_favorite_path_list do
          for l_path_index:= 0 to Count- 1 do
            with f_c_favorite_path(l_path_index) do
              if SameText(l_path, m_path) or SameText(l_path+ '\', m_path)
                then begin
                    m_c_list_box.ItemIndex:= l_path_index;

                    Break;
                  end;
      end; // handle_directory_listbox_click

    procedure c_favorite_path_list.handle_directory_listbox_drag_over(
        p_c_sender, p_c_source: TObject; p_x, p_y: Integer;
        p_drag_state: TDragState; var pv_accept: Boolean);
      begin
        pv_accept := p_c_sender= p_c_source;
      end; // handle_directory_listbox_drag_over

    procedure c_favorite_path_list.handle_directory_listbox_drag_dop(
        p_c_sender, p_c_source: TObject; p_x, p_y: Integer);
      var l_item_index, l_drop_index: Integer;
      begin
        with m_c_list_box do
        begin
          l_drop_index:= ItemAtPos(Point(p_x, p_y), True);
          if l_drop_index< 0
            then l_drop_index:= 0;
          if l_drop_index>= Count
            then l_drop_index:= Count- 1;
          // -- ItemIndex will be changed by the Exchange
          l_item_index:= ItemIndex;
          // display(Format('%d %d', [l_item_index, l_drop_index]));
          if l_drop_index= l_item_index
            then Exit;

          Items.Exchange(ItemIndex, l_drop_index);

          m_c_favorite_path_list.Exchange(l_item_index, l_drop_index);
        end; // with m_c_list_box

        // display_favorite_path_list;
        save_to_file;  
      end; // handle_directory_listbox_drag_dop

    function c_favorite_path_list.f_path_name_index(p_path_name: String): Integer;
      var l_path_index: Integer;
      begin
        Result:= -1;
        with m_c_favorite_path_list do
          for l_path_index:= 0 to Count- 1 do
            with f_c_favorite_path(l_path_index) do
              if SameText(p_path_name, m_path) or SameText(p_path_name+ '\', m_path)
                then begin
                    Result:= l_path_index;
                    Break;
                  end;
      end; // f_path_name_index

    procedure c_favorite_path_list.load_from_file(p_full_file_name: String);
      var l_list_index: Integer;
          l_the_line: String;
          l_index: integer;
          l_name, l_path_name, l_parameter: String;
          l_bar_position: Integer;
          l_path_name_index: integer;
          // l_caption,
          // l_c_favorite_path: c_favorite_path;
      begin
        // m_memo_count:= 1;
        with tStringList.Create do
        begin
          LoadFromFile(p_full_file_name);

          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Trim(Strings[l_list_index]);
            // display(l_the_line);
            if l_the_line= ''
              then begin
                  // Inc(m_memo_count);
                end
              else begin
                  l_index:= 1;
                  l_name:= f_string_extract_non_blank(l_the_line, l_index);
(*
                  l_path_name:= f_string_extract_non_blank(l_the_line, l_index);
                  l_parameter:= f_string_extract_non_blank(l_the_line, l_index);
*)
                  System.Delete(l_the_line, 1, l_index);
                  l_the_line:= Trim(l_the_line);

                  // -- avoid blanks such as "program files" !
                  l_bar_position:= Pos('|', l_the_line);
                  if l_bar_position> 0
                    then begin
                        l_path_name:= System.Copy(l_the_line, 1, l_bar_position- 1);
                        l_path_name:= Trim(l_path_name);

                        l_parameter:= l_the_line;
                        System.Delete(l_parameter, 1, l_bar_position);
                        l_parameter:= Trim(l_parameter);
                      end
                    else begin
                        l_the_line:= Trim(l_the_line);
                        l_index:= Length(l_the_line);
                        l_parameter:= '';
                        while (l_index> 1) and (l_the_line[l_index]<> ' ') do
                        begin
                          l_parameter:= l_the_line[l_index]+ l_parameter;
                          Dec(l_index);
                        end;
                        SetLength(l_the_line, l_index);
                        l_path_name:= Trim(l_the_line);
                      end;

                  l_path_name_index:= f_path_name_index(l_path_name);
                  if l_path_name_index>= 0
                    then begin
                        display('*** path_already_in '+ f_c_favorite_path(l_path_name_index).m_name);
                        Continue;
                      end;

                  if Not DirectoryExists(l_path_name)
                    Then begin
                        display('*** dir_not_found '+ l_path_name);
                        Continue;
                      end;

                  f_c_add_favorite_path(l_name, l_path_name, l_parameter);
                  // display(l_c_favorite_path.f_display_favorite_path);
                end;
          end; // for l_list_index

          Free;
        end; // with tStringList

        display_favorite_path_list;
      end; // load_from_file

    procedure c_favorite_path_list.save_to_file;
      // -- save and normalize
      var l_c_result_list: tStringList;
          l_favorite_path_index: Integer;
      begin
        l_c_result_list:= tStringList.Create;
        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          with f_c_favorite_path(l_favorite_path_index) do
            l_c_result_list.Add(Format('%-21s %-50s | %s',
                [m_name, f_without_ending_slash(m_path), f_normalized_parameter_list]));

        f_create_path(ExtractFilePath(m_full_file_name));        
        with l_c_result_list do
        begin
          SaveToFile(m_full_file_name);
          Free;
        end;
      end; // save_to_file

    Destructor c_favorite_path_list.Destroy;
      var l_favorite_path_index: Integer;
      begin
        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          f_c_favorite_path(l_favorite_path_index).Free;
        m_c_favorite_path_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_favorite_path_list
    end. // u_c_favorite_path_list
